import {
  __name
} from "./chunk-INDHDMU3.mjs";

// src/wrap.tsx
import { mergeProps as _mergeProps, createVNode as _createVNode, isVNode as _isVNode } from "vue";
import { mapResponsive } from "@chakra-ui/utils";
import { chakra } from "@chakra-ui/vue-system";
import { getValidChildren, SNAO } from "@chakra-ui/vue-utils";
import { tokenToCSSVar } from "@chakra-ui/styled-system";
import { computed, defineComponent } from "vue";
function _isSlot(s) {
  return typeof s === "function" || Object.prototype.toString.call(s) === "[object Object]" && !_isVNode(s);
}
__name(_isSlot, "_isSlot");
var wrapProps = {
  spacing: SNAO,
  justify: SNAO,
  align: SNAO,
  direction: SNAO,
  shouldWrapChildren: SNAO
};
var CWrap = defineComponent({
  props: {
    as: {
      type: [Object, String],
      default: "div"
    },
    ...wrapProps
  },
  setup(props, {
    slots,
    attrs
  }) {
    const styles = computed(() => ({
      "--chakra-wrap-spacing": (theme) => mapResponsive(props.spacing, (value) => tokenToCSSVar("space", value)(theme)),
      "--wrap-spacing": "calc(var(--chakra-wrap-spacing) / 2)",
      display: "flex",
      flexWrap: "wrap",
      justifyContent: props.justify,
      alignItems: props.align,
      flexDirection: props.direction,
      listStyleType: "none",
      padding: "0",
      margin: "calc(var(--wrap-spacing) * -1)",
      "& > *:not(style)": {
        margin: "var(--wrap-spacing)"
      }
    }));
    const childrenToRender = props.shouldWrapChildren ? getValidChildren(slots).map((child, index) => _createVNode(CWrapItem, {
      "key": index
    }, _isSlot(child) ? child : {
      default: () => [child]
    })) : slots;
    return () => {
      return _createVNode(chakra.div, _mergeProps({
        "as": props.as,
        "__label": "wrap"
      }, attrs), {
        default: () => _createVNode(chakra.ul, {
          "__label": "wrap__list",
          "__css": styles.value
        }, _isSlot(childrenToRender) ? childrenToRender : {
          default: () => [childrenToRender]
        })
      });
    };
  }
});
CWrap.name = "CWrap";
var CWrapItem = defineComponent({
  setup(_, {
    attrs,
    slots
  }) {
    return () => {
      return _createVNode(chakra.li, _mergeProps({
        "__label": "wrap__listItem",
        "__css": {
          display: "flex",
          alignItems: "flex-start"
        }
      }, attrs), {
        default: () => getValidChildren(slots)
      });
    };
  }
});
CWrapItem.name = "CWrapItem";

export {
  wrapProps,
  CWrap,
  CWrapItem
};
